	org $1001-2
	dw  $1001
	
rand = $D0

ticker_pos	= $FF0
dial_pos	= $FF1 ; 4 bytes
cursor_cnt	= $FF5
bigdial_pos	= $FF6 ; 4 bytes
fade_cnt	= $FFA
fade_delay	= $FFB
	
	dw nextln,0	; second word is line number
	db $9e
	if start > 9999
	db "0"+start/10000
	endif
	db "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
nextln	db 0,0
	
start
	sei
	sta $FF3F
	;
	lda #$CC
	cmp $FF1D
	bne *-3
	;
	;lda #$00
	;sta $FF19
	;
	lda #$0B	; turn graphics mode on
	sta $FF06
	;
	lda $FF07	; PAL/NTSC friendly
	and #$40
	ora #$08	; use $18 for multicolor
	sta $FF07
	;
	lda $FF12
	and #$03	; keep lowest 2 bits (sound)	
	ora #$08	; $08 = $2000, $10 = $4000, etc.
	sta $FF12
	;
	lda #$18	; color map at $1800
	sta $FF14
	;
	lda #irq & 255
	sta $FFFE
	lda #irq >> 8
	sta $FFFF
	;
	lda #$1A
	sta $FF0B
	;
	jsr InitRandom
	;
	lda #$00
	sta ticker_pos
	sta dial_pos+0
	sta dial_pos+1
	sta dial_pos+2
	sta dial_pos+3 
	sta cursor_cnt 
	sta bigdial_pos+0
	sta bigdial_pos+1
	sta bigdial_pos+2
	sta bigdial_pos+3 
	sta fade_cnt
	;
	jsr PLAYER_INIT
	;
	jsr call_fade
	;
	lda #$FF
	cmp $FF1D
	bne *-3
	asl $FF09
	;
	lda #$3B
	sta $FF06
	lda #$31
	sta $FF19
	;
	cli
	;
	jmp *
	;
irq	pha
	txa
	pha
	tya
	pha
	;
	asl $FF09
	;
	ldy #$A8		; horizontal sync position
	ldx #$00
	;
rloop	lda colors,x		; get the color (preload)
	;
s1	cpy $FF1E
	bcs s1			; horizontal sync
	;    
	sta $FF19		; set it to border
	sta $FF15		; ... and background = rasterbar!
	;
	inx
	bpl rloop
	;
	lda #$FF
s2	cmp $FF1D
	bne s2
	;
	lda #$31
	sta $FF19
	;
	jsr ticker
	;
	ldy #$00
	jsr dial
	;
	ldy #$01
	jsr dial
	;
	ldy #$02
	jsr dial
	;
	ldy #$03
	jsr dial
	;
	jsr cursor
	;
	ldy #$00
	jsr bigdial
	;
	ldy #$01
	jsr bigdial
	;
	ldy #$02
	jsr bigdial
	;
	ldy #$03
	jsr bigdial
	;
	jsr fade
	;
	jsr PLAYER
	;
	pla
	tay
	pla
	tax
	pla
	rti
	
load
	lda #$08
	sta $FF14
	lda #$C4
	sta $FF12
	lda #$D1
	sta $FF13
	lda #$0B
	sta $FF06
	lda $FF07
	and #$40
	ora #$08
	sta $FF07
	;
	sta $FF3E
	;
	ldx #$0F	; reset basic colors
cp1	lda $E143,x
	sta $0113,x
	dex
	bpl cp1
	;
	ldx #$FF
	txs
	;
	cli
	;
	lda #$00
	sta $053B
	lda #$93
	jsr $FFD2
	;
	lda #$F8
sn2	cmp $FF1D
	bne sn2
	;
	lda #$1B
	sta $FF06
	lda #$01
	sta $FF15
	sta $FF19
	;
	; ---
	;
	lda #$01	; logical number
	ldx #$08	; device number (8=disk)
	ldy #$01	; secondary address
	jsr $FFBA	; KERNAL: SETLFS
	;
	lda #fname_end - fname
	ldx #fname & 255
	ldy #fname >> 8
	jsr $FFBD	; KERNAL: SETNAM (Set length and filename address)
	;
	lda #$00	; 0=load
	sta $90		; clear error byte just in case
	jsr $FFD5	; KERNAL: LOADSP (Load from file)
	;
	; --- check for error
	;
	jsr $FFB7	; READSS, find out the status
	cmp #$00	; zero should mean no error
	beq NOERROR
	cmp #$40	; for serial devices, $40 means EOF was reached
	beq NOERROR
	;
	; --- disk error
	;
	lda #$0F
	ldx #$08
	tay
	jsr $FFBA	; KERNAL: SETLFS (Set LA, FA, SA) - OPEN 15, 8, 15
	;
	lda #$00
	jsr $FFBD	; KERNAL: SETNAM - no filename
	;
	jsr $FFC0	; KERNAL: OPEN (Open logical file)
	;
	ldx #$0F
	jsr $FFC6	; KERNAL: CHKIN (Open channel in)
	;
	lda #$80	; read a maximum of 128 chars
	sta $D0
	;
er1	jsr $EC8B	; Read one char
	jsr $FFD2	; KERNAL: BSOUT (Output to channel) - PRINT
	cmp #$0D	; C/R means end of information
	beq er2
	;
	dec $D0		; keep track of the read length to avoid infinite loops
	bne er1
	;
er2	lda #$0F
	jsr $FFC3	; KERNAL: CLOSE (Close logical file)
	;
	lda #$71	; reset colors
	sta $FF15
	lda #$6E
	sta $FF19
	;
	jsr $FF4F
	db "COULD NOT LOAD MAIN PROGRAM."
	db 0
	;
	jmp $8003	; READY.
	;
NOERROR	lda #$01	; set BASIC vectors to $4000
	sta $2B
	lda #$40
	sta $2C
	;
	lda #$00	; clear 4000 to avoid syntax error
	sta $4000
	;
	lda $9D		; copy load end address to BASIC vectors
	sta $2D
	sta $2F
	sta $31
	lda $9E
	sta $2E
	sta $30
	sta $32
	;
	lda #$80	; flag gfx area allocated
	sta $75
	;lda #$03	; mode 3 (but gfx is not turned on)
	;sta $65
	;lda #$20
	;sta $83
	;
	jsr $8BBE	; BASIC RUN command
	jmp $8BDC
	
fname
	db "HAUPTPRO*"
fname_end

fade
	ldy fade_delay
	iny
	cpy #$04
	bne fd2
	;
	inc fade_cnt
call_fade
	ldx fade_cnt
	lda fade_colors,x
	bne fd1
	;
	sei
	lda #$00
	sta $FF11
	jmp load
	;
fd1	and #$0F
	ora #$70
	sta $19F1
	sta $19F2
	sta $19F3
	sta $19F4
	sta $19F5
	;
	sta $1A19
	sta $1A1A
	sta $1A1B
	sta $1A1C
	sta $1A1D
	;
	lda fade_colors,x
	and #$F0
	ora #$01
	sta $1DF1
	sta $1DF2
	sta $1DF3
	sta $1DF4
	sta $1DF5
	;
	sta $1E19
	sta $1E1A
	sta $1E1B
	sta $1E1C
	sta $1E1D
	;
	ldy #$00
fd2	sty fade_delay
	rts
	
fade_colors
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	;
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	;
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	;
	db $17,$17,$17,$17
	db $16,$15,$14,$13
	db $12,$12,$12,$12
	db $12,$12,$12,$12
	;
	db $13,$23,$83,$93
	db $73,$A3,$F3,$53
	db $C3,$33,$D3,$63
	db $E3,$43,$B3,$B4
	
	db $44,$E4,$64,$D4
	db $34,$C4,$54,$F4
	db $A4,$74,$94,$84
	db $24,$14,$14,$15
	db $16,$17,$17,$17
	;
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	;
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	;
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17,$17
	db $17,$17,$17
	;
	db $00
	
cursor
	ldx cursor_cnt
	inx
	cpx #$10
	bne cr1
	;
	lda $2E4F
	eor #$C0
	sta $2E4F
	lda $2E4E
	eor #$C0
	sta $2E4E
	;
	ldx #$00
cr1	stx cursor_cnt
	rts
	
ticker
	ldx #$04
t0	cpx ticker_pos
	beq t0a
	lda $2329,x
	ora #$01
	sta $2329,x
t0a	dex
	bpl t0
	;
	ldx #$04
t1	sec
	rol $2329,x
	rol $2321,x
	rol $2319,x
	rol $2311,x
	dex
	bpl t1
	;
	ldx #$04
t2	lda $2311,x
	and #$7F
	sta $2311,x
	;
	lda $2329,x
	and #$FE
	sta $2329,x
	dex
	bpl t2
	;
	jsr GetRandom
	cmp #$50
	bcc ticker_up
	;
	cmp #$B0
	bcs ticker_down
	;
	; 70-90: straight
	;
	rts
	
ticker_up
	ldx ticker_pos
	beq ticker_down
	;
	dex
	stx ticker_pos
	rts
	
ticker_down
	ldx ticker_pos
	cpx #$04
	beq ticker_up
	;
	inx
	stx ticker_pos
	rts
	
dial
	jsr GetRandom
	cmp #$50
	bcc dial_up
	;
	cmp #$B0
	bcs dial_down
	;
	; straight
	;
	jmp dial_straight
	
dial_up
	lda dial_pos,y
	beq dial_down
	;
	sec
	sbc #$01
	sta dial_pos,y
	jmp dial_straight
	
dial_down
	lda dial_pos,y
	cmp #$07
	beq dial_up
	;
	clc
	adc #$01
	sta dial_pos,y
	;
dial_straight
	lda dial_ptr_lo,y
	sta dial_ptr+1
	lda dial_ptr_hi,y
	sta dial_ptr+2
	;
	lda dial_pos,y
	asl a
	asl a
	asl a
	tax
	ldy #$00
cd1	lda dials,x
dial_ptr
	sta $2440,y
	inx
	iny
	cpy #$08
	bne cd1
	;
	;lda dial1+1
	;clc
	;adc #$08
	;and #$3F
	;sta dial1+1
	;
	rts
	
dial_ptr_lo
	db $40,$50,$68,$78
dial_ptr_hi
	db $24,$24,$24,$24
	
bigdial
	jsr GetRandom
	cmp #$50
	bcc bigdial_up
	;
	cmp #$B0
	bcs bigdial_down
	;
	; straight
	;
	jmp bigdial_straight
	
bigdial_up
	lda bigdial_pos,y
	beq bigdial_down
	;
	sec
	sbc #$01
	sta bigdial_pos,y
	jmp bigdial_straight
	
bigdial_down
	lda bigdial_pos,y
	cmp #$06
	beq bigdial_up
	;
	clc
	adc #$01
	sta bigdial_pos,y
	;
bigdial_straight
	lda bigdial_ptr_lo,y
	sta bigdial_ptr+1
	lda bigdial_ptr_hi,y
	sta bigdial_ptr+2
	;
	lda bigdial_pos,y
	asl a
	asl a
	asl a
	asl a
	tax
	ldy #$00
cbd1	lda bigdials,x
bigdial_ptr
	sta $2440,y
	inx
	iny
	cpy #$10
	bne cbd1
	;
	;lda dial1+1
	;clc
	;adc #$08
	;and #$3F
	;sta dial1+1
	;
	rts
	
bigdial_ptr_lo
	db $70,$80,$B0,$C0
bigdial_ptr_hi
	db $20,$20,$20,$20
	
colors
	db $31,$00,$31,$00
	db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	db 0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0,0,0,0,0,0,0
	db 0
	db $23,$23,$23,$23,$23,$23,$23,$23
	db $23,$23,$23,$23,$23,$23,$23,$23
	db $33,$33,$33,$33,$33,$33,$33,$33
	db $33,$33,$33,$33,$33,$33,$33,$33
	db $33,$33,$33,$33,$33,$33,$33,$33
	db $33,$33,$33,$33,$33,$33,$33,$33
	db $33,$33,$33,$33,$33,$33,$33,$33
	
	include "random.asm"
	
dials
	include "dials.asm"
bigdials
	include "bigdials.asm"
	
	include "tune3.asm"
	
	org $1800
picture
	include "picture.asm"
;eof