base = $C0

vtick	= base + 0
ch1tick	= base + 1
ch2tick	= base + 2
ch1i	= base + 3
ch2i	= base + 4

F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

C0 =	$0007	; +1
Ci0 =	$0040
D0 =	$0076
Di0 =	$00A9	; -1
E0 =	$00D9
F0 =	$0106
Fi0 =	$0131
G0 =	$0159	;  0
Gi0 =	$017F	; -2/+2
A0 =	$01A3
Ai0 =	$01C5
B0 =	$01E5
C1 =	$0204	; -2/+2
Ci1 =	$0220
D1 =	$023B
Di1 =	$0254	; -2/+2
E1 =	$026C
F1 =	$0283
Fi1 =	$0298
G1 =	$02AD	; +1
Gi1 =	$02C0	; -2/+2
A1 =	$02D2
Ai1 =	$02E3
B1 =	$02F3
;---
C2 =	$0302	; Notes above $0300
Ci2 =	$0310
D2 =	$031E
Di2 =	$032A
E2 =	$0336
F2 =	$0342
Fi2 =	$034C
G2 =	$0356
Gi2 =	$0360
A2 =	$0369
Ai2 =	$0371
B2 =	$0379
C3 =	$0381
Ci3 =	$0388
D3 =	$038F
Di3 =	$0395
E3 =	$039B
F3 =	$03A1
Fi3 =	$03A6
G3 =	$03AB
Gi3 =	$03B0
A3 =	$03B4
Ai3 =	$03B9
B3 =	$03BD
C4 =	$03C0
Ci4 =	$03C4
D4 =	$03C7
Di4 =	$03CB
E4 =	$03CE
F4 =	$03D0
Fi4 =	$03D3
G4 =	$03D6
Gi4 =	$03D8
A4 =	$03DA
Ai4 =	$03DC
B4 =	$03DE
;	$03E0
;	$03E2
;	$03E4
OFF =	$03FE

PLAYER_INIT
	ldx #$01
	stx vtick
	stx ch1tick
	stx ch2tick
	dex
	stx ch1i
	stx ch2i
	;
	lda F1HI
	ora #$03
	sta F1HI
	rts
	
PLAYER
	;
	; ### Channel 1
	;
	dec ch1tick
	bne no_tick_ch1
	;
	ldx ch1i
read_ch1
	lda channel1,x
	bne no_ch1_wrap
	;
	ldx #$00
	stx ch1i
	beq read_ch1
no_ch1_wrap
	sta ch1tick
	;
	lda channel1+1,x
	sta F1LO
	;
	inx
	inx
	stx ch1i	
	;
no_tick_ch1
	;
	; ### Channel 2
	;
	dec ch2tick
	bne no_tick_ch2
	;
reset_ch2
	ldx ch2i
	lda channel2,x
	bne no_ch2_wrap
	;
	sta ch2i
	beq reset_ch2
no_ch2_wrap
	sta F2LO
	;
	lda channel2+1,x
	tay
	and #$03
	sta F2HI
	tya
	lsr a
	tay
	lsr a
	and #$0F
	sta ch2tick
	tya
	and #$60
	sta noise+1
	;
	inx
	inx
	stx ch2i
	;
no_tick_ch2
	;
	; ### Volume control
	;
	ldx vtick
	dex
	bne no_tick_wrap
	;
	ldx #(volmap_end-volmap)
no_tick_wrap
	stx vtick
	;
	lda F2LO		; no click
	cmp #$FE
	bne svol
	lda F1LO
	cmp #$FE
	beq nsvol
	;
svol	lda volmap-1,x
noise	ora #$00
	sta $FF11
	;
nsvol	rts

volmap
	db $11,$12,$13,$14,$15,$16
volmap_end

	db $AA
	
channel1
	db 6*32, OFF & 255	; pause
	;
	db 6*1+0,C2  & 255	; lead 1
	db 6*1+0,C2  & 255
	db 6*1+0,C3  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,G2  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,C2  & 255
	;
	db 6*1+0,F2  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,Di2 & 255
	db 6*1+0,C2  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,F2  & 255
	db 6*1+0,G2  & 255
	;
	db 6*1+0,C2  & 255	; lead 1
	db 6*1+0,C2  & 255
	db 6*1+0,C3  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,G2  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,C2  & 255
	;
	db 6*1+0,F2  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,Di2 & 255
	db 6*1+0,C2  & 255
	db 6*1+0,C2  & 255
	db 6*1+0,F2  & 255
	db 6*1+0,G2  & 255
	;
	db $00 ; end flag
	
channel2
	dw 2 << 13 | (6*1+0)<<10 | C0
	dw 2 << 13 | (6*1+0)<<10 | OFF
	dw 2 << 13 | (6*1+0)<<10 | C0
	dw 2 << 13 | (6*1+0)<<10 | OFF
	;
	dw 4 << 13 | (1*1+0)<<10 | $3D5
	dw 4 << 13 | (1*1+0)<<10 | $3C5
	dw 2 << 13 | (4*1+0)<<10 | OFF
	;
	dw 2 << 13 | (6*1+0)<<10 | C0
	dw 2 << 13 | (6*1+0)<<10 | OFF
	dw 2 << 13 | (6*1+0)<<10 | C1
	dw 2 << 13 | (6*1+0)<<10 | OFF
	dw 2 << 13 | (6*1+0)<<10 | C0
	dw 2 << 13 | (6*1+0)<<10 | OFF
	dw 2 << 13 | (6*1+0)<<10 | C0
	;
	dw 4 << 13 | (1*1+0)<<10 | $3D3
	dw 4 << 13 | (1*1+0)<<10 | $3C3
	dw 2 << 13 | (4*1+0)<<10 | C0
	;
	dw 2 << 13 | (6*1+0)<<10 | OFF
	dw 2 << 13 | (6*1+0)<<10 | C1
	dw 2 << 13 | (6*1+0)<<10 | OFF
	;
	db $00
;eof